#include <iostream>
#include "saddle.h"
#define MAX_N 505
using namespace std;

long long nums[MAX_N];

pair <int, int> find_saddle_point (int N, int M)
{
    if(N==1)
    {
        nums[0]=value(0, 0);
        nums[1]=value(0, 1);

        if(nums[0]<nums[1])
        {
            return {0, 0};
        }

        for(int i=1; i<M; i++)
        {
            nums[i+1]=value(0, i+1);
            if(nums[i]<nums[i+1] && nums[i-1]>nums[i])
            {
                return {0, i};
            }
        }
        if(nums[M]<nums[M-1])
        {
            return {0, M};
        }
    }
    return {1, 1};
}
