#include <iostream>
#include "saddle.h"
#define MAX_N 505
using namespace std;

long long nums[MAX_N];

pair <int, int> find_saddle_point (int N, int M)
{
    if(N==1)
    {
        nums[1]=value(1, 1);
        nums[2]=value(1, 2);

        if(nums[1]<nums[2])
        {
            return {1, 1};
        }

        for(int i=3; i<M; i++)
        {
            nums[i]=value(1, i);
            if(nums[i-1]<nums[i] && nums[i-2]>nums[i-1])
            {
                return {1, i-1};
            }
        }
        return {1, M};

    }
    return {1, 1};
}
