#include<iostream>
#include "saddle.h"

using namespace std;
const int MAXNN = 505;

long long marked[MAXNN][MAXNN];
long long nn, mm, val[MAXNN][MAXNN];
int find_val(int r, int c)
{
    if(r < 1 || r > nn || c < 1 || c > mm)return 0;
    // cout << r << " " << c << endl;
    if(marked[r][c])return val[r][c];
    marked[r][c] = 1;
    val[r][c] = value(r, c);
    return val[r][c];
}
bool tryit(int r, int c)
{
    int bigger = 0;
    long long curr = find_val(r, c);
    if(find_val(r-1, c) < curr)bigger = 1;
    if(find_val(r+1, c) < curr)bigger = 1;
    if(find_val(r, c-1) < curr)bigger = 1;
    if(find_val(r, c+1) < curr)bigger = 1;
    if(!bigger)
        return true;
    else return false;
}
pair <int, int> find_saddle_point (int N, int M)
{
    nn = N;
    mm = M;
    for (int i = 1; i <= nn; ++ i)
    {
        for (int j = 1; j <= mm; ++ j)
        {
            int row = i;
                      int col = j;
            //  cout << row << " " << col << endl;
            if(tryit(row, col))return make_pair(row, col);
        }
    }

}

