#include <bits/stdc++.h>
using namespace std;
const long long MAXN = 22;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
long long n, k, m;
struct edge
{
    long long x, y, w;
    edge(){};
    edge(long long _x, long long _y, long long _w)
    {
        x = _x;
        y = _y;
        w = _w;
    }
};
vector < edge > g;
bool cmp(edge e1, edge e2)
{
    return (e1.w < e2.w);
}
long long special[MAXN];
void read()
{
    cin >> n >> k >> m;
    long long ver;
    for (long long i = 1; i <= k; ++ i)
    {
        cin >> ver;
        special[ver] = 1;
    }
    long long xx, yy, ww;
    for (long long i = 1; i <= m; ++ i)
    {
        cin >> xx >> yy >> ww;
        g.push_back(edge(xx, yy, ww));
    }
    sort(g.begin(), g.end(), cmp);
}

long long use[MAXN];
long long p[MAXN];
long long theans;
long long find_leader(long long i)
{

    if(i == p[i])return i;
    else return (p[i] = find_leader(p[i]));
}
bool connected(long long i, long long j)
{
    i = find_leader(i);
    j = find_leader(j);
    if(i == j)return true;
    else return false;
}
void check()
{

    long long cnt = 0;
    for (long long i = 1; i <= n; ++ i)
    {
        cnt += use[i];
        p[i] = i;

    }
    long long from, to, w;
    long long ans = 0;
    long long need = cnt - 1;
    for (long long i = 0; i < g.size() && need; ++ i)
    {

        from = g[i].x;
        to = g[i].y;
        w = g[i].w;
        if(!use[from] || !use[to])continue;
        if(connected(from, to))continue;
        ans += w;
        p[to] = from;
        need --;

    }
    if(!need)theans = min(theans, ans);

}
void gen(long long pos)
{
    if(pos == n+1)
    {
        check();
        return;
    }
    if(!special[pos])
    {
        use[pos] = 0;
        gen(pos + 1);
    }
    use[pos] = 1;
    gen(pos+1);
}
int main()
{//
    speed();
    theans = 1e17;

    read();

    gen(1);
    cout << theans << endl;
    return 0;
}
