#include <bits/stdc++.h>
using namespace std;
struct edge
{
    long long x,d;
    edge(){}
    edge(long long _x,long long _d)
    {
        x=_x;
        d=_d;
    }

    bool operator<(const edge&e)const
    {
        return e.d<d;
    }
};

long long n,m;
vector<edge> v[100001];
long long c,p[16];

void read()
{
    cin>>n>>c>>m;
    for(long long i=1;i<=c;i++)
        cin>>p[i];
    for(long long i=1;i<=m;i++)
    {
        long long x,y,z;
        cin>>x>>y>>z;
        v[x].push_back({y,z});
        v[y].push_back({x,z});
    }
}

long long d[100001][8];

void dijkstra(long long s,long long num)
{
    for(long long i=1;i<=n;i++)
        d[i][num]=1e18;
    priority_queue<edge> q;
    d[s][num]=0;
    q.push({s,0});
    while(q.size())
    {
        edge e=q.top();
        q.pop();

        if(d[e.x][num]>=e.d)
        {
            for(long long i=0;i<v[e.x].size();i++)
            {
                edge nb=v[e.x][i];
                if(d[nb.x][num]>d[e.x][num]+nb.d)
                {
                    d[nb.x][num]=d[e.x][num]+nb.d;
                    q.push({nb.x,d[nb.x][num]});
                }
            }
        }
    }
}

long long ans[100001][16];

void dijkstra2(long long num)
{
    priority_queue<edge> q;
    for(long long i=1;i<=n;i++)
        q.push({i,ans[i][num]});

    while(q.size())
    {
        edge e=q.top();
        q.pop();

        if(ans[e.x][num]>=e.d)
        {
            for(long long i=0;i<v[e.x].size();i++)
            {
                edge nb=v[e.x][i];
                if(ans[nb.x][num]>ans[e.x][num]+nb.d)
                {
                    ans[nb.x][num]=ans[e.x][num]+nb.d;
                    q.push({nb.x,ans[nb.x][num]});
                }
            }
        }
    }
}

void solve()
{
    long long fin=1e18;
    for(long long i=1;i<=c;i++)
    {
        for(long long j=1;j<=n;j++)
        {
            ans[j][i]=d[j][i]+ans[j][i-1];
        }
        dijkstra2(i);
    }

    for(int i=1;i<=n;i++)
        fin=min(fin,ans[i][c]);
    cout<<fin<<endl;
}

int main()
{
    read();
    for(long long i=1;i<=c;i++)
        dijkstra(p[i],i);
    solve();

    return 0;
}
