#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e5+2;
int n, p1[maxn], p2[maxn], i1[maxn], i2[maxn], len1, len2;
bool lamp = false;
pair <int, int> a[maxn];

void print()
{
    if (lamp) return;
    lamp = true;
    if (len1 == 0)
    {
        p1[(++len1)] = p2[len2];
        i1[len1] = i2[len2];
        -- len2;
    }
    if (len2 == 0)
    {
        p2[(++len2)] = p1[len1];
        i2[len2] = i1[len1];
        -- len1;
    }

    cout << len1 << " " << len2 << '\n' ;
    int i;
    for (i=1; i<=len1; ++i)
        cout << i1[i] << " " ;
    cout << '\n' ;
    for (i=1; i<=len2; ++i)
        cout << i2[i] << " " ;
    cout << '\n' ;
}

void solve()
{
    int i, r1 = p1[2] - p1[1], r2 = p2[2] - p2[1];
    len1 = 2, len2 = 2;
    for (i=5; i<=n; ++i)
    {
        if (a[i].first - p1[len1] == r1)
        {
            p1[(++len1)] = a[i].first;
            i1[len1] = a[i].second;
        }
        else if (a[i].first - p2[len2] == r2)
        {
            p2[(++len2)] = a[i].first;
            i2[len2] = a[i].second;

        }
        else if (len1 > 0 && a[i].first - p1[len1] == r2 && p1[len1] - p2[len2] == r2)
        {
            p2[(++len2)] = p1[len1];
            i2[len2] = i1[len1];
            p1[len1] = 0, i1[len1] = 0;
            -- len1;
            p2[(++len2)] = a[i].first;
            i2[len2] = a[i].second;
        }
        else if (len2 > 0 && a[i].first - p2[len2] == r1 && p2[len2] - p1[len1] == r1)
        {
            p1[(++len1)] = p2[len2];
            i1[len1] = i2[len2];
            p2[len2] = 0, i2[len2] = 0;
            -- len2;
            p1[(++len1)] = a[i].first;
            i1[len1] = a[i].second;
        }
        else return;
    }

    print();
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n ;
    int i;
    for (i=1; i<=n; ++i)
    {
        cin >> a[i].first ;
        a[i].second = i;
    }

    if (n == 2)
    {
        cout << "1 1" << '\n' ;
        cout << "1" << '\n' ;
        cout << "2" << '\n' ;
        return;
    }
    if (n == 3)
    {
        cout << "1 2" << '\n' ;
        cout << "1" << '\n' ;
        if (a[2].first < a[3].first)
            cout << "2 3" << '\n' ;
        else
            cout << "3 2" << '\n' ;
        return;
    }

    sort(a+1, a+n+1);
    p1[1] = a[1].first, p1[2] = a[2].first;
    i1[1] = a[1].second, i1[2] = a[2].second;
    p2[1] = a[3].first, p2[2] = a[4].first;
    i2[1] = a[3].second, i2[2] = a[4].second;
    solve();

    memset(p1, 0, sizeof(p1));
    memset(p2, 0, sizeof(p2));
    p1[1] = a[1].first, p1[2] = a[3].first;
    i1[1] = a[1].second, i1[2] = a[3].second;
    p2[1] = a[2].first, p2[2] = a[4].first;
    i2[1] = a[2].second, i2[2] = a[4].second;
    solve();

    memset(p1, 0, sizeof(p1));
    memset(p2, 0, sizeof(p2));
    p1[1] = a[1].first, p1[2] = a[4].first;
    i1[1] = a[1].second, i1[2] = a[4].second;
    p2[1] = a[2].first, p2[2] = a[3].first;
    i2[1] = a[2].second, i2[2] = a[3].second;
    solve();

    if (lamp == false)
    {
        cout << "-1" << '\n' ;
        return;
    }
}

int main()
{
    read();
    return 0;
}