#include<bits/stdc++.h>
#include "saddle.h"
using namespace std;

const int maxn = 512;
long long a[maxn][maxn];
bool used[maxn][maxn];
int nn, mm, nb1x, nb1y, nb2x, nb2y, nb3x, nb3y, nb4x, nb4y;

bool valid(int x, int y)
{
    if (x < 1 || x > nn) return false;
    if (y < 1 || y > mm) return false;
    return true;
}

bool check_cell(int&i, int&j)
{
    if (used[i][j]) return false;
    used[i][j] = true;
    if (a[i][j] == 0)
        a[i][j] = value(i, j);

    nb1x = i-1, nb1y = j;
    if (valid(nb1x, nb1y))
    {
        if (a[nb1x][nb1y] == 0)
            a[nb1x][nb1y] = value(nb1x, nb1y);
        if (a[i][j] > a[nb1x][nb1y])
            return false;
    }

    nb2x = i+1, nb2y = j;
    if (valid(nb2x, nb2y))
    {
        if (a[nb2x][nb2y] == 0)
            a[nb2x][nb2y] = value(nb2x, nb2y);
        if (a[i][j] > a[nb2x][nb2y])
            return false;
    }

    nb3x = i, nb3y = j+1;
    if (valid(nb3x, nb3y))
    {
        if (a[nb3x][nb3y] == 0)
            a[nb3x][nb3y] = value(nb3x, nb3y);
        if (a[i][j] > a[nb3x][nb3y])
            return false;
    }

    nb4x = i, nb4y = j-1;
    if (valid(nb4x, nb4y))
    {
        if (a[nb4x][nb4y] == 0)
            a[nb4x][nb4y] = value(nb4x, nb4y);
        if (a[i][j] > a[nb4x][nb4y])
            return false;
    }
    return true;
}

pair <int, int> find_saddle_point (int N, int M)
{
    mt19937 mt;
    nn = N, mm = M;
    int k = (N*M);
    int i, j, x;
    while (true)
    {
        x = mt() % k;
        ++ x;
        j = x % M;
        i = (x / M) + 1;
        if (j == 0)
        {
            j = M;
            -- i;
        }

        //cout << i << " " << j << '\n' ;
        if (check_cell(i,j))
            return {i,j};
    }
}

/*
3 4
5 3 5 6
10 6 4 10
2 9 8 2
*/