#include <iostream>
#include <algorithm>
#include <vector>
#define MAX_N 100005
#define MAX_M 1000000009
using namespace std;

int trees[MAX_N];
bool nums[MAX_M];
int n;
vector<int> one;
vector<int> two;

bool check()
{
    //cout << "####";
    bool mark;
    for(int i=0; i<n; i++)
    {
        mark=false;
        for(int j=0; j<one.size(); j++)
        {
            //cout << trees[i] << " " << one[j] << endl;
            if(trees[i]==one[j])
            {
                mark=true;
                break;
            }
        }
        if(!mark)
        {
            two.push_back(trees[i]);
        }
    }
    for(int i=2; i<two.size(); i++)
    {
        if(two[i]-two[i-1]!=two[i-1]-two[i-2])
        {
            return false;
        }
    }
    return true;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for(int i=0; i<n; i++)
    {
        cin >> trees[i];
        nums[trees[i]]=true;
    }

    sort(trees, trees+n);
    int maxd=trees[n-1]-trees[0];

    for(int c1=1; c1<n; c1++)
    {
        for(int start=0; start<=n-c1; start++)
        {
            for(int diff=1; diff<=maxd; diff++)
            {
                one.clear();
                two.clear();
                for(int i=0; i<c1; i++)
                {
                    if(nums[trees[start]+i*diff])
                    {
                        //cout << c1 << " " << start << " " << diff << " " << trees[start]+i*diff << endl;
                        one.push_back(trees[start]+i*diff);
                    }
                    else
                    {
                        break;
                    }
                }
                //cout << "^^^" << c1 << " " << one.size() << endl;
                if(one.size()==c1)
                {
                    //cout << "*****" << c1 << " " << start << " " << diff << endl;
                    if(check())
                    {
                        cout << one.size() << " " << two.size() << endl;
                        for(int i=0; i<one.size(); i++)
                        {
                            cout << one[i] << " ";
                        }
                        cout << endl;
                        for(int i=0; i<two.size(); i++)
                        {
                            cout << two[i] << " ";
                        }
                        return 0;
                    }
                }
            }
        }
    }


    cout << -1;


    return 0;
}

