#include <bits/stdc++.h>
#include "saddle.h"
using namespace std;

struct node
{
    int x,y;
    node(){}
    node(int _x,int _y)
    {
        x=_x;
        y=_y;
    }

    node operator+(node n)
    {
        return {x+n.x,y+n.y};
    }
};

node mv[4]={{1,0},{0,1},{-1,0},{0,-1}};
int nn,mm;
int a[512][512];
pair<int,int> ans;

bool in_(node v)
{
    int x=v.x,y=v.y;
    return x>=1&&x<=nn&&y>=1&&y<=mm;
}

int get_(node x)
{
    if(a[x.x][x.y]==0)a[x.x][x.y]=value(x.x,x.y);
    //cout<<x.x<<" * "<<x.y<<" "<<a[x.x][x.y]<<endl;
    return a[x.x][x.y];
}
int used[512][512];
bool o;
void dfs(node i)
{
    if(o)return;
    bool in=0;
    used[i.x][i.y]=1;
    for(int j=0;j<4;j++)
    {
        node nb=mv[j]+i;
        //cout<<nb.x<<" "<<nb.y<<endl;
        if(in_(nb)&&get_(nb)<get_(i))
        {
            dfs(nb),in=1;
        }
    }

    if(in==0)
    {
        ans={i.x,i.y};
        o=1;
    }
}

pair<int,int> find_saddle_point(int N,int M)
{
    nn=N;
    mm=M;
    for(int i=1;i<=nn;i++)
    {
        for(int j=1;j<=mm;j++)
        {
            a[i][j]=value(i,j);
        }
    }

    for(int i=1;i<=nn;i++)
    {
        for(int j=1;j<=mm;j++)
        {
            node f={i,j};
            //cout<<i<<" - "<<j<<endl;
            bool good=1;
            for(int k=0;k<4;k++)
            {
                node nb=f+mv[k];
                if(in_(nb)&&a[nb.x][nb.y]<a[i][j])
                {
                    //cout<<a[nb.x][nb.y]<<endl;
                    good=0;
                }
            }
            if(good)ans={i,j};
        }
    }
    return ans;
}
/*
3 4
5 3 5 6
10 6 4 10
2 9 8 2
*/
